# bootbin.mk - generated from ../bootbin.conf by crunchgen 1.3

.include <bsd.own.mk>
CFLAGS+=$(NOPIE_FLAGS)
LDFLAGS+=$(NOPIE_LDFLAGS)
STRIP?=strip
LINK=$(LD) -dc -r ${LDFLAGS}
LIBS= -L/usr/lib -lutil -lotermcap -ll -lm -lcrypto
CRUNCHED_OBJS= ksh.lo ln.lo mount.lo mount_ffs.lo mount_cd9660.lo mount_msdos.lo umount.lo newfs.lo sleep.lo
SUBMAKE_TARGETS= ksh_make ln_make mount_make mount_ffs_make mount_cd9660_make mount_msdos_make umount_make newfs_make sleep_make

CLIB=
.if defined(SRCLIBDIR)
. for lib in ${LIBS:M-l*:S/-l//}
.  if exists(${SRCLIBDIR}/lib${lib})
CLIB+=lib${lib}.a
.  endif
. endfor
.endif

bootbin: bootbin.o $(CRUNCHED_OBJS) ${CLIB}
	$(CC) -static -L. ${LDFLAGS} -o $@ bootbin.o $(CRUNCHED_OBJS) $(LIBS)
	$(STRIP) bootbin

.if !empty(CLIB)
.SUFFIXES: .a .olist
.olist.a:
	@rm -f ${.TARGET}
	@cd ${SRCLIBDIR}/${.PREFIX} &&				\
	${MAKE} DIST_OBJS="`cat ${.OBJDIR}/${.IMPSRC}`"		\
	    DIST_LIB=${.OBJDIR}/${.TARGET} ${.OBJDIR}/${.TARGET}

bootbin.map: bootbin.o $(CRUNCHED_OBJS)
	$(CC) -static ${LDFLAGS} -o bootbin.o.o bootbin.o $(CRUNCHED_OBJS) \
	    $(LIBS) -Wl,-M | sed -e '/^Allocating/q' >${.TARGET}

${CLIB:.a=.olist}: bootbin.map
	sed -n -e 's!^${DESTDIR}/usr/lib/${.TARGET:R}\.a(\([^)]*\.o\)).*!\1!p' \
	    < bootbin.map | tr '\012' ' ' >$@
.endif

all: objs exe
objs: $(SUBMAKE_TARGETS)
exe: bootbin
clean:
	rm -f bootbin *.lo *.o *_stub.c
.PHONY: all objs exe clean $(SUBMAKE_TARGETS)


# -------- ksh

ksh_SRCDIR=/usr/src/distrib/special/ksh
ksh_OBJS= alloc.o c_ksh.o c_sh.o c_test.o c_ulimit.o edit.o emacs.o eval.o exec.o expr.o history.o io.o jobs.o lex.o mail.o main.o mknod.o misc.o path.o shf.o syn.o table.o trap.o tree.o tty.o var.o version.o vi.o
ksh_make:
	cd $(ksh_SRCDIR) && exec $(MAKE) -f Makefile $(ksh_OBJS)

ksh_OBJPATHS= /usr/src/distrib/special/ksh/alloc.o /usr/src/distrib/special/ksh/c_ksh.o /usr/src/distrib/special/ksh/c_sh.o /usr/src/distrib/special/ksh/c_test.o /usr/src/distrib/special/ksh/c_ulimit.o /usr/src/distrib/special/ksh/edit.o /usr/src/distrib/special/ksh/emacs.o /usr/src/distrib/special/ksh/eval.o /usr/src/distrib/special/ksh/exec.o /usr/src/distrib/special/ksh/expr.o /usr/src/distrib/special/ksh/history.o /usr/src/distrib/special/ksh/io.o /usr/src/distrib/special/ksh/jobs.o /usr/src/distrib/special/ksh/lex.o /usr/src/distrib/special/ksh/mail.o /usr/src/distrib/special/ksh/main.o /usr/src/distrib/special/ksh/mknod.o /usr/src/distrib/special/ksh/misc.o /usr/src/distrib/special/ksh/path.o /usr/src/distrib/special/ksh/shf.o /usr/src/distrib/special/ksh/syn.o /usr/src/distrib/special/ksh/table.o /usr/src/distrib/special/ksh/trap.o /usr/src/distrib/special/ksh/tree.o /usr/src/distrib/special/ksh/tty.o /usr/src/distrib/special/ksh/var.o /usr/src/distrib/special/ksh/version.o /usr/src/distrib/special/ksh/vi.o
ksh_stub.c:
	@echo "int _crunched_ksh_stub(int argc, char **argv, char **envp) { return main(argc, argv, envp); }" >$@
ksh.lo: ksh_stub.o $(ksh_OBJPATHS)
	$(LINK) -o $@ ksh_stub.o $(ksh_OBJPATHS)
	crunchgen -h  -k _crunched_ksh_stub $@

# -------- ln

ln_SRCDIR=/usr/src/distrib/special/ln
ln_OBJS= ln.o
ln_make:
	cd $(ln_SRCDIR) && exec $(MAKE) -f Makefile $(ln_OBJS)

ln_OBJPATHS= /usr/src/distrib/special/ln/ln.o
ln_stub.c:
	@echo "int _crunched_ln_stub(int argc, char **argv, char **envp) { return main(argc, argv, envp); }" >$@
ln.lo: ln_stub.o $(ln_OBJPATHS)
	$(LINK) -o $@ ln_stub.o $(ln_OBJPATHS)
	crunchgen -h  -k _crunched_ln_stub $@

# -------- mount

mount_SRCDIR=/usr/src/distrib/special/mount
mount_OBJS= mount.o
mount_make:
	cd $(mount_SRCDIR) && exec $(MAKE) -f Makefile $(mount_OBJS)

mount_OBJPATHS= /usr/src/distrib/special/mount/mount.o
mount_stub.c:
	@echo "int _crunched_mount_stub(int argc, char **argv, char **envp) { return main(argc, argv, envp); }" >$@
mount.lo: mount_stub.o $(mount_OBJPATHS)
	$(LINK) -o $@ mount_stub.o $(mount_OBJPATHS)
	crunchgen -h  -k _crunched_mount_stub $@

# -------- mount_ffs

mount_ffs_SRCDIR=/usr/src/distrib/special/mount_ffs
mount_ffs_OBJS= mount_ffs.o getmntopts.o
mount_ffs_make:
	cd $(mount_ffs_SRCDIR) && exec $(MAKE) -f Makefile $(mount_ffs_OBJS)

mount_ffs_OBJPATHS= /usr/src/distrib/special/mount_ffs/mount_ffs.o /usr/src/distrib/special/mount_ffs/getmntopts.o
mount_ffs_stub.c:
	@echo "int _crunched_mount_ffs_stub(int argc, char **argv, char **envp) { return main(argc, argv, envp); }" >$@
mount_ffs.lo: mount_ffs_stub.o $(mount_ffs_OBJPATHS)
	$(LINK) -o $@ mount_ffs_stub.o $(mount_ffs_OBJPATHS)
	crunchgen -h  -k _crunched_mount_ffs_stub $@

# -------- mount_cd9660

mount_cd9660_SRCDIR=/usr/src/distrib/special/mount_cd9660
mount_cd9660_OBJS= mount_cd9660.o getmntopts.o
mount_cd9660_make:
	cd $(mount_cd9660_SRCDIR) && exec $(MAKE) -f Makefile $(mount_cd9660_OBJS)

mount_cd9660_OBJPATHS= /usr/src/distrib/special/mount_cd9660/mount_cd9660.o /usr/src/distrib/special/mount_cd9660/getmntopts.o
mount_cd9660_stub.c:
	@echo "int _crunched_mount_cd9660_stub(int argc, char **argv, char **envp) { return main(argc, argv, envp); }" >$@
mount_cd9660.lo: mount_cd9660_stub.o $(mount_cd9660_OBJPATHS)
	$(LINK) -o $@ mount_cd9660_stub.o $(mount_cd9660_OBJPATHS)
	crunchgen -h  -k _crunched_mount_cd9660_stub $@

# -------- mount_msdos

mount_msdos_SRCDIR=/usr/src/distrib/special/mount_msdos
mount_msdos_OBJS= mount_msdos.o getmntopts.o
mount_msdos_make:
	cd $(mount_msdos_SRCDIR) && exec $(MAKE) -f Makefile $(mount_msdos_OBJS)

mount_msdos_OBJPATHS= /usr/src/distrib/special/mount_msdos/mount_msdos.o /usr/src/distrib/special/mount_msdos/getmntopts.o
mount_msdos_stub.c:
	@echo "int _crunched_mount_msdos_stub(int argc, char **argv, char **envp) { return main(argc, argv, envp); }" >$@
mount_msdos.lo: mount_msdos_stub.o $(mount_msdos_OBJPATHS)
	$(LINK) -o $@ mount_msdos_stub.o $(mount_msdos_OBJPATHS)
	crunchgen -h  -k _crunched_mount_msdos_stub $@

# -------- umount

umount_SRCDIR=/usr/src/distrib/special/umount
umount_OBJS= umount.o
umount_make:
	cd $(umount_SRCDIR) && exec $(MAKE) -f Makefile $(umount_OBJS)

umount_OBJPATHS= /usr/src/distrib/special/umount/umount.o
umount_stub.c:
	@echo "int _crunched_umount_stub(int argc, char **argv, char **envp) { return main(argc, argv, envp); }" >$@
umount.lo: umount_stub.o $(umount_OBJPATHS)
	$(LINK) -o $@ umount_stub.o $(umount_OBJPATHS)
	crunchgen -h  -k _crunched_umount_stub $@

# -------- newfs

newfs_SRCDIR=/usr/src/distrib/special/newfs
newfs_OBJS= dkcksum.o getmntopts.o newfs.o mkfs.o
newfs_make:
	cd $(newfs_SRCDIR) && exec $(MAKE) -f Makefile $(newfs_OBJS)

newfs_OBJPATHS= /usr/src/distrib/special/newfs/dkcksum.o /usr/src/distrib/special/newfs/getmntopts.o /usr/src/distrib/special/newfs/newfs.o /usr/src/distrib/special/newfs/mkfs.o
newfs_stub.c:
	@echo "int _crunched_newfs_stub(int argc, char **argv, char **envp) { return main(argc, argv, envp); }" >$@
newfs.lo: newfs_stub.o $(newfs_OBJPATHS)
	$(LINK) -o $@ newfs_stub.o $(newfs_OBJPATHS)
	crunchgen -h  -k _crunched_newfs_stub $@

# -------- sleep

sleep_SRCDIR=/usr/src/distrib/special/sleep
sleep_OBJS= sleep.o
sleep_make:
	cd $(sleep_SRCDIR) && exec $(MAKE) -f Makefile $(sleep_OBJS)

sleep_OBJPATHS= /usr/src/distrib/special/sleep/sleep.o
sleep_stub.c:
	@echo "int _crunched_sleep_stub(int argc, char **argv, char **envp) { return main(argc, argv, envp); }" >$@
sleep.lo: sleep_stub.o $(sleep_OBJPATHS)
	$(LINK) -o $@ sleep_stub.o $(sleep_OBJPATHS)
	crunchgen -h  -k _crunched_sleep_stub $@

# ========
